#ifndef _RLL_H
#define _RLL_H
#ifndef _SYS_TYPES
#include <sys/types.h>
#endif
#ifndef _THINGS_H
#include <things.h>
#endif
typedef struct {
THING_LINKAGE linkage;
char th_filler[15];
THING_HEADER header;
long rll_rlib;
long rll_xdef;
long rll_xref;
long rll_bss;
int (*rll_loadinit)();
int (*rll_linkinit)();
long rll_udata;
long rll_fwdl;
long rll_revl;
short rll_time;
short rll_cnt;
long rll_jbst;
} RLL_HEADER;
#define RLLFLAG"THG%"
#define RLLTYPE 0
#define RLLIDEN"<<RLL>>"
typedef struct {
char bss_iden[8];
long bss_rlib;
long bss_xdef;
long bss_xref;
long bss_reloc;
} BSS_HEADER;
#define BSSFLAG"<<BSS>>"
typedef struct {
char rlib_iden[8];
short rlib_count;
struct {
char rlib_version[4];
char rlib_name[16];
} rll[1];
} BSS_RLIB;
#define BSS_RLIBFLAG"<<RLIB>>"
typedef struct {
char xdef_iden[8];
long xdef_offset;
char xdef_name[1];
} BSS_XDEF;
#define BSS_XDEFFLAG"<<XDEF>>"
#define BSS_XREFFLAG"<<XREF>>"
#define BSS_XDEF_END 0x00
#define BSS_XDEF_SKIP 0xfffe
struct {
char reloc_iden;
long reloc_init;
unsigned char bss_next;
} BSS_RELOC;
#define BSS_RELOCFLAG"<<RELOC>>"
#define BSS_RELOC_END 0x00
#define BSS_RELOC_SKIP 0xff
typedef struct {
long vers;
short namelen;
unsigned char name[40];
RLL_HEADER rll;
} RLL_FILE_DETAILS;
typedef struct {
long flag;
long type;
long base;
long call;
} RLM_HEADER;
typedef struct {
unsigned char dbgdir[34];
unsigned char libdir[34];
short timeout;
short debug;
short mode;
} RLM_READVALUES;
#ifdef __STDC__
#define _P_(params) params
#else
#define _P_(params)
#endif
int RLM_LinkCode _P_((char *,BSS_HEADER *,jobid_t,chanid_t));
int RLM_LoadLib _P_((char *,timeout_t,chanid_t));
int RLM_SetTimeout _P_((short));
int RLM_SetLoadMode _P_((short));
int RLM_SetLoadDir _P_((char *));
int RLM_SetDebugDir _P_((char *));
int RLM_SetDebugMode _P_((short));
int RLM_ReadVariables _P_((RLM_READVALUES *));
int RLM_RelocLD _P_((char *,BSS_HEADER *));
int RLM_RelocGST _P_((char *,long *));
int RLM_RelocLD_Old _P_((char *,void *));
#undef _P_
#endif
